#!/usr/bin/python3
# -- coding: UTF-8 --

"""
 * kare system dbus registration
 *
 * Copyright (C) 2023-2025, KylinSoft Co., Ltd.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library.  If not, see <https://www.gnu.org/licenses/>.
 *
 * Authors: Huazhi Zhou <zhouhuazhi@kylinos.cn>
 *
 """

import gi
gi.require_version('Gtk', '3.0')
from gi.repository import GLib, Gtk, Gio
from pydbus import SystemBus
import subprocess

loop = GLib.MainLoop()

class KARE():
    """
    <node>
        <interface name='com.kylin.kare.host'>
            <method name='command' >
                <arg type='s' direction='out' name='ret'/>
                <arg type='s' direction='in' name='ret'/>
            </method>
        </interface>
    </node>
    """

    def command(self, cmd) -> str:
        ret = subprocess.getoutput("command -v {}".format(cmd))
        return ret   

bus = SystemBus()
bus.publish("com.kylin.kare.host", KARE())
loop.run()
